import { ConstraintViolation } from './constraint-violation';
/**
 * Optional details of the error
 */
export interface ErrorDetails {
    /**
     * reference to the error occurrence in the internal self-monitoring, logging, etc.
     */
    errorRef?: string;
    /**
     * A list of constraint violations of input parameters (path, query, request body)
     */
    constraintViolations?: ConstraintViolation[];
    /**
     * In case of a 403 - Forbidden response, a list of missing scopes necessary to successfully execute the request
     */
    missingScopes?: string[];
}
