import { ErrorDetails } from './error-details';
/**
 * Error object for an incomplete response
 */
export interface ErrorIncomplete {
    /**
     * The error code (HTTP response)
     */
    code: number;
    /**
     * The error message
     */
    message: string;
    /**
     * Number of seconds a request can be retried after a 'too many requests' error response.
     */
    retryAfterSeconds?: number;
    /**
     * Optional details of the error
     */
    details?: ErrorDetails;
}
