import { ErrorDetails } from './error-details';
/**
 * Standard error response
 */
export interface Error {
    /**
     * The error code (HTTP response)
     */
    code: number;
    /**
     * The error code (HTTP response)
     */
    message: string;
    /**
     * Number of seconds a request can be retried after a 'too many requests' error response.
     */
    retryAfterSeconds?: number;
    /**
     * Optional details of the error
     */
    details?: ErrorDetails;
}
