/**
 * Modification information about the app setting.
 */
export interface AppSettingsModificationInfo {
    /**
     * The unique identifier of the user who created the app setting.
     */
    createdBy?: string;
    /**
     * Timestamp when the app settings was created in ISO 8601 format (yyyy-MM-dd'T'HH:mm:ss.SSS'Z')
     */
    createdTime?: Date;
    /**
     * The unique identifier of the user who performed the most recent modification.
     */
    lastModifiedBy?: string;
    /**
     * Timestamp when the app setting was last modified in ISO 8601 format (yyyy-MM-dd'T'HH:mm:ss.SSS'Z')
     */
    lastModifiedTime?: Date;
}
