/**
 * The response to a creation request.
 */
export interface AppSettingsObjectResponse {
    /**
     * The ID of the created settings object.
     */
    objectId: string;
    /**
     * The version of the object for optimistic locking. You can use it to detect simultaneous modifications by different users.
     *
     * It is generated upon retrieval (GET requests). If set on update (PUT request) or deletion, the update/deletion will be allowed only if there wasn't any change between the retrieval and the update.
     */
    version: string;
}
