export interface AnalyzerExecutionLog {
    /**
     * Determines the severity of the log.
     */
    level: 'TRACING' | 'INFO' | 'WARNING' | 'SEVERE';
    message: string;
    /**
     * A path pointing to the source of the error in the input. The format of the path follows
     * the [JSON path specification](https://goessner.net/articles/JsonPath/).
     */
    path?: string;
}
