import { AnalyzerDimensionalData } from './analyzer-dimensional-data';
import { AnalyzerExecutionLog } from './analyzer-execution-log';
import { AnalyzerInput } from './analyzer-input';
import { AnalyzerOutput } from './analyzer-output';
export interface AnalyzerResult {
    /**
     * The uniquely identifying ID of the result. Used for logging.
     */
    resultId: string;
    resultStatus: 'SUCCESSFUL' | 'SUCCESSFUL_WITH_WARNINGS' | 'FAILED';
    executionStatus: 'RUNNING' | 'ABORTED' | 'COMPLETED';
    /**
     * The input is specific to an analyzer. Get the definition of the analyzer to retrieve the required input structure.
     */
    input: AnalyzerInput;
    logs?: AnalyzerExecutionLog[];
    output: AnalyzerOutput[];
    data?: AnalyzerDimensionalData[];
}
