export interface DirectShare {
    /**
     * System-generated id.
     */
    id: string;
    /**
     * The shared document's id.
     */
    documentId: string;
    /**
     * The access granted by this share.
     */
    access: string[];
    /**
     * Number of users who have been directly assigned to this share and therefore can access the document and collaborate on it. Not that potentially assigned groups and their users (see groupCount) are not reflected in this number.
     */
    userCount: number;
    /**
     * Number of groups which have been assigned to this share.
     */
    groupCount: number;
}
