import { CreationInfo } from './creation-info';
/**
 * Metadata of a snapshot of a document.
 */
export interface SnapshotMetadata {
    /**
     * System-maintained auto-incremented snapshot version, starting at 1.
     *
     * This is not the document version.
     */
    snapshotVersion: number;
    /**
     * The document version associated with this snapshot. The document had this version when the snapshot was created.
     */
    documentVersion: number;
    /**
     * An optional description of the snapshot's content or the changes it introduces to the previous snapshot. Provided by the user or app.
     */
    description?: string;
    /**
     * Info related to creation of the entity.
     */
    modificationInfo: CreationInfo;
}
