import { FormDataRequestBody, FormDataRequestField, FormDataResponseBody } from '@dynatrace-sdk/http-client';
type TransformRuleConfig = {
    force?: boolean;
    datetime?: boolean;
};
export declare function transformRequest<T = any>(object: T, keys: Array<string | [string, TransformRuleConfig]>): T;
export declare function transformResponse<T = any>(object: T, keys: Array<string | [string, TransformRuleConfig]>): T;
export interface FormDataRequestFieldDefinition {
    key: string;
    type: 'text' | 'json' | 'binary';
    required: boolean;
}
export interface FormDataResponseGenericFieldDefinition {
    type: 'text' | 'binary';
}
export interface FormDataResponseJsonFieldDefinition {
    type: 'json';
    transformations: Array<string | [string, TransformRuleConfig]>;
}
export type FormDataResponseFieldDefinition = FormDataResponseGenericFieldDefinition | FormDataResponseJsonFieldDefinition;
export declare function transformToFormData<T extends Record<any, any>>(value: T, fields: Array<FormDataRequestFieldDefinition>): FormDataRequestBody;
export declare function transformToFormDataField<T = any>(value: T, field: FormDataRequestFieldDefinition): FormDataRequestField | null;
export declare function transformFromFormData<T extends Record<any, any>>(formData: FormDataResponseBody, fields: Record<string, FormDataResponseFieldDefinition>): T;
export {};
