export interface ErrorDetails {
    /**
     * Error code indicating the reason why the request failed
     *   * `AppStateOverallSizeLimitExceeded` - The overall size limit for the combined size of app states of this app was exceeded
     *   * `AppStateSizeLimitExceeded` - The app state value exceeded the size limit for a single app state
     *   * `UserAppStateSizeLimitExceeded` - The user app state content exceeded the size limit for a single user app state
     *   * `UserAppStateCountLimitExceeded` - The maximum number of user app states for this user and app was exceeded
     */
    errorCode?: 'AppStateOverallSizeLimitExceeded' | 'AppStateSizeLimitExceeded' | 'UserAppStateSizeLimitExceeded' | 'UserAppStateCountLimitExceeded';
}
