import { AnalyzerResult, analyzersClient } from '@dynatrace-sdk/client-davis-analyzers';
import { HookOptions } from './types/HookOptions';
/**
 * Provides the parameters for executeAnalyzer.
 */
export type AnalyzerParams = Omit<Parameters<typeof analyzersClient.executeAnalyzer>[0], 'abortSignal'>;
/**
 * Execute an analyzer with the given data.
 * @param params Parameters for the client sdk call.
 * @param {HookOptions} [options={ autoFetch: true, autoFetchOnUpdate: true }] - Additional options for the react hook.
 */
export declare const useAnalyzer: (params: AnalyzerParams, options?: HookOptions) => {
    data: AnalyzerResult | undefined;
    error: Error | undefined;
    errorDetails: import("@dynatrace-sdk/client-davis-analyzers").AnalyzerError | undefined;
    isError: boolean;
    isLoading: boolean;
    isSuccess: false | AnalyzerResult | undefined;
    status: import("./react-async-hook/react-async-hook").AsyncStateStatus;
    refetch: (...args: string[]) => Promise<AnalyzerResult | undefined>;
    cancel: () => void;
};
